﻿namespace IRCSharp.Tests.States;

[TestClass]
public class Sasl
{
    private Server _server;

    [TestInitialize]
    public void TestInitialize()
    {
        _server = new("test");
        _server.Parse(new("900 * nick!user@host account"));
    }

    [TestMethod]
    public void LoggedIn()
    {
        Assert.AreEqual("nick", _server.NickName);
        Assert.AreEqual("user", _server.UserName);
        Assert.AreEqual("host", _server.HostName);
        Assert.AreEqual("account", _server.Account);
    }

    [TestMethod]
    public void LoggedOut()
    {
        _server.Parse(new("901 * nick1!user1@host1"));

        Assert.AreEqual("nick1", _server.NickName);
        Assert.AreEqual("user1", _server.UserName);
        Assert.AreEqual("host1", _server.HostName);
        Assert.IsTrue(string.IsNullOrEmpty(_server.Account));
    }
}